/*
	this is a generic system("cmd") for Turbo C. it is intended
	to correct the failure of the Turbo C system() command to
	check the SHELL/COMSPEC variables and the switch char
	setting. in addition it works around bugs in some versions
	of the mks toolkit.

	the mks toolkit shell does not properly handle
	sh -c prog arg0 arg1 argn
	the command is converted to sh -c 'prog arg0 arg1 argn'

	getcwd is used for return to the current directory.

*/
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<process.h>
#include	<io.h>
#include	<dos.h>
#include	<dir.h>
#define		FNMSIZ		128
#define		FUBAR		69
#define		isnull(a)((a == NULL || *a == NULL) ? 1 : 0)
/*EXTERN*/
extern char *strxty(char *,char,char);
extern int nowswitch(int);
extern void toexit(void);
/**/
#ifndef		__TURBOC__
#define		const	/**/
#endif
/**/
static		char	*flc = "-c";
/**/
char	*
strxty(os,ca,cb)
char	*os;
char	ca;
char	cb;
{
	register	char	*osx = os;
	register	char	cax = ca;
	while(*osx != 0)
	if(*osx == cax)	*osx++ = cb;
	else			osx += 1;
	return(os);
}
void
toexit()
{
	fprintf(stderr,"<exit to return from shell>\n");
	return;
}
system(is)
const	char	*is;
{
	auto	char	*shell;
	auto	char	*sname;
	auto	int		ret;
	auto	char	cwd[FNMSIZ];
	auto	char	sc[3];
	sc[0] = nowswitch(0);
	sc[1] = 'c';
	sc[2] = 0;
/**/
#ifdef	DEBUG
	fprintf(stderr,"system(%s)\n",is);
	sleep(5);
#endif	/*DEBUG*/
/**/
	shell = getenv("SHELL");
	if(shell == NULL)	{
		fprintf(stderr,"system: <!cmd requires SHELL in environment>\n");
		return(FUBAR);
		}
/**/
	strlwr(shell);
	strxty(shell,'\\','/');
/**/
	if(access(shell,05))	{
		fprintf(stderr,"system <cannot find> '%s'\n",shell);
		return(-1);
		}
/**/
	sname = strrchr(shell,'/');
	if(sname != NULL)	sname += 1;
	else				sname = shell;
/**/
	getcwd(cwd,FNMSIZ);
/**/
	if(stricmp(sname,"sh.exe") == 0)			{
		if(isnull(is))	{
			toexit();
			sc[1] = 'i';
#ifdef	DEBUG
	fprintf(stderr,"shell(%s) sname(%s) sc(%c) is(%s)\n",
		shell,sname,sc[0],is);
	sleep(5);
#endif	/*DEBUG*/
			ret = spawnl(P_WAIT,shell,sname,sc,NULL);
			}
		else	{
#ifdef	DEBUG
	fprintf(stderr,"shell(%s) sname(%s) sc(%c) is(%s)\n",
		shell,sname,sc[0],is);
	sleep(5);
#endif	/*DEBUG*/
			ret = spawnl(P_WAIT,shell,sname,sc,"'",is,"'",NULL);
			}
		}
	else
	if(stricmp(sname,"command.com") == 0)	{
		if(isnull(is))	{
			toexit();
#ifdef	DEBUG
	fprintf(stderr,"shell(%s) sname(%s) sc(%c) is(%s)\n",
		shell,sname,sc[0],is);
	sleep(5);
#endif	/*DEBUG*/
			ret = spawnl(P_WAIT,shell,sname,NULL);
			}
		else	{
/*
	apparently command.com barfs on the form -c 'string'
*/
#ifdef	DEBUG
	fprintf(stderr,"shell(%s) sname(%s) sc(%c) is(%s)\n",
		shell,sname,sc[0],is);
	sleep(5);
#endif	/*DEBUG*/
			ret = spawnl(P_WAIT,shell,sname,sc,is,NULL);
			/* ret = spawnl(P_WAIT,shell,sname,sc,"'",is,"'",NULL); */
			}
		}
	else	{
		fprintf(stderr,"system: <unknown SHELL> '%s'\n",sname);
		return(FUBAR);
		}
/**/
	if(ret < 0)	{
		perror(shell);
		}
/**/
	chdir(cwd);
/**/
	return(ret);
}
nowswitch(cx)
int	cx;
{
	union	REGS	regs;
	auto	int	pc;
/*	
*	change switch character or return previous
*
*	Alan Holub, C CHEST, p. 146.
*/
/*	get previous */
	regs.x.dx = cx;
	regs.x.ax = 0x3700;
	intdos(&regs,&regs);
	pc = regs.h.dl;
/*  set current */
	if(cx)	{
		regs.x.dx = cx;
		regs.x.ax = 0x3701;
		intdos(&regs,&regs);
		}
/*	return previous */
#ifdef	DEBUG
	fprintf(stderr,"cx(%c) pc(%c)\n",cx,pc);
	sleep(5);
#endif	/*DEBUG*/
	return(pc);
}
#ifdef	TEST
main()
{
	auto	char	ls[BUFSIZ];
	while(putchar('+'),fflush(stdout),gets(ls))
	switch(ls[0])	{
		case	'Q':
		case	'q':	exit(0);
		case	'!':	system(ls+1);break;
		case	'/':
		case	'-':	nowswitch(ls[0]);
		case	'?':	printf("%c\n",nowswitch(0));
						break;
		default:		puts("!cmd");
						puts("? current switch char");
						puts("- set switch char");
						puts("/ set switch char");
		}
}
#endif	/*TEST*/
