/*
**	87:08:27	revised to use table for command parsing
**				bug in zap function fixed
*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "keddefs.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
#include	"synproto.h"
/**/
#define     S_MAX   10		/* max parameters */
#define		S_MAC	1		/* expandable macros */
#define		S_KIO	2		/* saved kedio */
#define		memnull(a,b)memset(a,0,b)
/*EXTERN*/
extern	KENV	kenv;
/*STATIC*/
static	int		secho		=	NO;
static  char    pf      	=   '$';
/**/
static	SYN_DEF	*sbo;			/* base */
/**/
SYNPAR	synp[] = {
	"help",4, 	(FUNCP) synhelp,ZERO,
	"hint",4, 	(FUNCP) synhelp,ZERO,
	"noec",4, 	(FUNCP) synecho,ZERO,
	"echo",4, 	(FUNCP) synecho,ZERO,
	"save",4, 	(FUNCP) syn_save,S_MAC,
	"zap",3,	(FUNCP) zap_syn,S_MAC,
	"undef",5,	(FUNCP)	rem_syn,S_MAC,
	"def",3,	(FUNCP)	def_syn,S_MAC,
	}	;
/**/
static	synsize = sizeof(synp)/sizeof(SYNPAR);
/**/
void
def_syn(is,ty)	/* define or remove a synonym */
int		ty;
char 	*is;
{
	auto	char	*nm;
	auto	char	*tx;
/**/
	is = totext(is);
/**/
	if(isnull(is)) {		/* no command specified */
		syn_save(is,ty);	/* print current list */
		return;
		}
/**/
	tx = strtoc(nm = is,' ');	/* split name, text */
/**/
	if(isnull(tx))	rem_syn(nm,ty);		/* no text, just remove */
	else			add_syn(nm,tx,ty);	/* new text */
/**/
	return;
}
void
add_syn(os,is,ty)	/* add a synonym, text pair */
char	*os;		/* name */
char	*is;		/* text */
int		ty;			/* function type */
{
	REG		SYN_DEF	*sbx = is_syn(os,ty);
/**/
	if(sbx)	{
		if(isnull(is))	rem_syn(os,ty);	/* null text -> remove */
		else	{	/* replace previous text */
			sbx->text = stringer(is,sbx->text);
			sbx->sflag = ty;
			}
		return;
		}
/**/
	sbx = (SYN_DEF*) emalloc(sizeof(SYN_DEF),"add_syn");
/**/
	memnull( (char *) sbx, sizeof(SYN_DEF) );
/**/
	sbx->sname = strsave(os);
	sbx->text = strsave(is);
/**/
	sbx->sflag = ty;
/**/
	if(sbo)	sbx->next = sbo;
	sbo = sbx;
/**/
	return;
}
void
zap_syn()		/* remove all definitions */
{
	REG		SYN_DEF	*sbx = sbo;
	while(sbx)	{
		free_if(sbx->text);
		free_if(sbx->sname);
		free_if((char *) sbx);
		sbx = sbx->next;
		}
	sbo = (SYN_DEF *)	NULL;
	return;
}
void
rem_syn(is,ty)		/* remove a specific item */
int	ty;
char 	*is;
{
	REG		SYN_DEF	*sbz;
	REG		SYN_DEF	*sbx;
	sbz = is_syn(is,ty);
	if(!sbz)	return;
	sbz->sname = free_if(sbz->sname);
	sbz->text = free_if(sbz->text);
	free_if((char *) sbz);
	if(sbz == sbo)	{
		sbo = sbz->next;
		return;
		}
	sbx = sbo;
	while(sbx)	{
		if(sbx->next == sbz)	{
			sbx->next = sbz->next;
			break;
			}
		sbx = sbx->next;
		}
	return;
}
SYN_DEF	*
is_syn(is,ty)		/* does is name an item in the list */
int		ty;			/* item type */
char	*is;		/* item name */
{
	REG	SYN_DEF	*sbx = sbo;
	if(is == NULL)	badcall("is_syn");
	strcnd(is);
	while(sbx)	{
		if(sbx->sflag == ty &&
			*sbx->sname == *is &&
				strcmp(sbx->sname,is) == 0)	return(sbx);
	sbx = sbx->next;
	}
	return((SYN_DEF *) NULL);
}
void
syn_save(is,ty)			/* save or print macros */
char	*is;
int		ty;
{
	REG		SYN_DEF		*sbx = sbo;
	auto	FILE		*fp;
	if(!sbo) {
		printff("\007<no synonyms or macros>\n");
		return;
		}
/***decide on file name***/
	if(is == NULL)					fp = stdout;
	else							{
		strcnd(is);
		if(isnull(is))				is = "synsaves.tmp";
		fp = tefopen(is,"w");
/* CHECK */
	}
/***no writes to stdout if not interactive***/
	if(fp == stdout && !(kenv.prompt & DA))	return;
/***write to file***/
	if(kenv.leisur & DA)			scr_cl(fp);
/**/
	while(sbx)	{
		if(sbx->sflag == ty)
		fprintf(fp,"syn def %s %s\n",sbx->sname,sbx->text);
	sbx = sbx->next;
	}
/**/
	xfclose(fp);
	if(kenv.leisur & DB)			query(fp);
	if(kenv.leisur & DA)			scr_cl(fp);
	return;
}
char	*
get_syn(is)			/* return expanded synonym */
char 	*is;		/* no ty in this call! */
{
	auto	char 	ws[FNMSIZ];
	auto	char	*wp[S_MAX];
	auto	char	os[FNMSIZ];
	REG		char	*osx = os;
	REG		char	*mtx;
	auto	SYN_DEF	*sbx;
	auto	int	pn = 0;
	*osx = ZERO;
	strcpy(ws,is);
	getqs(wp,S_MAX,ws);
	if(!(sbx = is_syn(wp[0],S_MAC)))	return(is);
	mtx = sbx->text;
	while(*mtx != ZERO) {
		if(*mtx == '\\' && *(mtx+1) == pf) {
			mtx++;
			*osx++ = *mtx++;
			}
		else
		if(*mtx == pf && isdigit(mtx[1])) {
			pn = atoi(mtx+1);
			osx = strkat(osx,os+FNMSIZ-1,wp[pn]);
			mtx += 2;
			continue;
			}
		else 	{
			*osx++ = *mtx++;
			}
		}
	*osx++ = ZERO;
	strcpy(is,os);
	if(secho)	printff("%s\n",is);
	return(is);
}
void
synhelp(is)		/* display help function */
char	*is;
{
	khint(kenv.pname,"MACROS");
}
void
synecho()		/* echo or not echo expansions */
{
	secho = !secho;
}
/**/
void
synsyn(is)	/* scan list of functions */
char    *is;
{
	REG		SYNPAR	*synx = synp;
	REG		SYNPAR	*synu = synp + synsize;
/**/
	is = totext(is);
/**/
	while(synx < synu)	{	/* look for a function, otherwise print */
		if(strncmp(is,synx->cname,synx->skip) == 0)	{
			(*synx->fu)(is + synx->skip, synx->type);
			return;
			}
		synx += 1;
		}
/**/
	syn_save(NULL,S_MAC);	/* default: print macros */
	return;
}
void
iosave(os,is)	/* save last key for kedio */
char	*os;	/* int key */
char	*is;	/* data */
{
	add_syn(os,is,S_KIO);
}
char	*
iopull(is)		/* get saved key for kedio */
char	*is;
{
	auto	SYN_DEF	*sbx = is_syn(is,S_KIO);
/**/
	if( (int) sbx)	return(sbx->text);
	else			return(NULL);
/**/
}
badcall(is)
char	*is;
{
	errmsg("<bad call> %s\n",is);
	terror(FUBAR);
}
