#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"ksysgrph.h"
/**/
setgraph(lxx,lyy,ndxx,ndyy,xxmin,xxmax,yymin,yymax)
int lxx,lyy,ndxx,ndyy;
double xxmin,xxmax,yymin,yymax;
{
	int i = 0;
	int j = 0;
	lx = lxx; ly = lyy; ndx = ndxx; ndy = ndyy;
	xmin = xxmin; xmax = xxmax; ymin = yymin; ymax = yymax;
	/* check scale factors; adjust as necessary */
	if(lx > MAXLX) lx = MAXLX;
	if(lx < MINLX) lx = MINLX;
	if(lx != lxx) fprintf(stderr,"lx changed from %d to %d\n",lxx,lx);
	if(ndx > MAXDX) ndx = MAXDX;
/**/
	if(ndx <= 5)	ndx = 5;
	while(lx % ndx)	ndx=ndx-1;
	if(ndx <= 1)	ndx = 1;
	if(ndx != ndxx) fprintf(stderr,"ndx changed from %d to %d\n",ndxx,ndx);
/**/
	if(ly > MAXLY) ly = MAXLY;
	if(ly < MINLY) ly = MINLY;
	if(ly != lyy) fprintf(stderr,"ly changed from %d to %d\n",lyy,ly);
	if(ndy > MAXDY) ndy = MAXDY;
/**/
	if(ndy <= 5)    ndy = 5;
	while(ly % ndy) ndy=ndy-1;
	if(ndy <= 0)    ndy = 1;
	if(ndy != ndyy) fprintf(stderr,"ndy changed from %d to %d\n",ndyy,ndy);
/**/
	xrange = xmax-xmin;
	yrange = ymax-ymin;
	xintv = xrange/lx;
	yintv = yrange/ly;
	xno[0] = xmin;
	/* make tic mark labels for x and y borders */
	for(i = 1; i <= ndx; i++)
		xno[i] = xmin + i*xrange/ndx;
	yno[0] = ymin;
	for(i = 1; i <= ndy; i++)
		yno[i] = ymin + i*yrange/ndy;
	nddx = lx/ndx;
	nddy = ly/ndy;
	/* draw graph borders */
	gpx = graph;
	for(i = 0; i < MAXGRPH; i++)
		*(gpx + i) = ' ';
	gpx = graph;
	for(i = 0; i <=ly; i++)
	{
	ylp[i] = gpx;
	if(i % nddy)
		{
		*gpx = '|'; gpx = gpx + lx; *gpx = '|';
		}
	else
		{
		*gpx = '+'; gpx = gpx + lx; *gpx = '+';
		}
	gpx = gpx + 1;
	*gpx = ZERO;
	gpx = gpx + 1;
	}
	for(i = 1; i < lx; i++)
	{
	if(i % nddx)
	{
	*(ylp[0] + i) = '-';
	*(ylp[ly] + i) = '-';
	}
	else
	{
	*(ylp[0]+i) = '+';
	*(ylp[ly]+i) = '+';
	}
	}
	if(form & DA)
	{
	for(i = 1; i < ly; i++)
		for(j = 1; j < lx; j++)
			if(j % nddx) continue;
			else *(ylp[i]+j) = '|';
	for(i = 1; i < ly; i++)
		if(i % nddy) continue;
		else for (j = 1; j <lx; j++)
			if(j % nddx) *(ylp[i] +j) = '-';
	}
	return(1);
}
graphit(nsfx,nsfy,xt,yt,gh,ofp)
int nsfx,nsfy;			/* significant digits for tic mark labels */
char *xt,*yt,*gh;		/* pointers to labels and heading */
FILE	*ofp;
{
	int i = 0;
	int len, lenc,lyc,j,ns,inc,lxc,start;
	auto	char 	blank[MAXLN +1];
	auto	char	work[MAXLN +1];
/**/
	scr_cl(ofp);
	printf("lx = %d ly = %d\n",lx,ly);
/**/
	for(i = 0; i < MAXLN; i++)
	    *(blank + i) = ' ';
	    *(blank + i) = ZERO;
	len = strlen(gh);
	if(len > lx) len = lx;
	lenc = len/2;
	lxc = lx/2;
	for(i = 0; i < MAXLN; i++)
	    *(work + i) = ' ';
	    *(work + i) = ZERO;
	start = lxc - lenc;
	if(start < 0) start = 0;
	sncopy(work+start,gh,len);
	*(work + start + len) = ZERO;
	if(len == 0) *work = ZERO;
	fprintf(ofp,"\n\n%s%s\n",blank+MAXLN-1 -OFFSET,work);
	/* set up y axis label */
	len = strlen(yt);
	if(len > ly) len = ly;
	lyc = ly/2;
	lenc = len/2;
	for(i = 0; i < MAXLN; i++)
		*(work + i) = ' ';
		*(work + i) = ZERO;
	start = lyc - lenc;
	if(start < 0) start = 0;
	strncpy(work+start,yt,len);
	/* basic print loop */
	for(i = ly, j = 0; i >= 0; i--,j++) {
	if(i % nddy)
        sprintf(pxline,"\n%c%s%s",work[j],blank+MAXLN + 1 -OFFSET,ylp[i]);
	else
	sprintf(pxline,"\n%c   %10.*f %s",work[j],nsfy,yno[i/nddy],ylp[i]);
	gprint(pxline,ofp);
	}
	/*x tic mark labels */
	ns = lx/ndx;
	inc = 10/ns + 1;	/* number of label lines to be printed */
	fill = (inc*lx)/ndx -10;	/* amount of fill needed */
	if(inc <= 0) inc =1;
	for(j = 0; j < inc; j++)
	{
	fprintf(ofp,"\n%*s",(6+j*ns),"");
	for(i = j; i <= ndx; i = i + inc)
	{
	if(i > j) fwd = fill;
	else fwd = 0;
	fprintf(ofp,"%*s%10.*f",fwd,"",nsfx,xno[i]);
	}
	}
	/* x axis label */
	len = strlen(xt);
	if(len > lx) len = lx;
	lenc = len/2;
	lxc = lx/2;
	for(i = 0; i < MAXLN; i++)
		*(work + i) = ' ';
		*(work + i) = ZERO;
	start = lxc - lenc;
	if(start < 0) start = 0;
	sncopy(work+start,xt,len);
	*(work+start+len) = ZERO;
	if(len == 0) *work = ZERO;
	fprintf(ofp,"\n%s%s\n",blank+MAXLN - 1 -OFFSET,work);
	return(ZERO);
}
datain(fc,gc,x,y)
int	fc;
int	gc;
double	x;
double	y;
{
	auto	int	xp;
	auto	int	yp;
	auto	double	llx;
	auto	double	lly;
	auto	double	fudge;
	/* find associated y line */
	lly = ly;
	fudge = 0.0;
	if(y > 0) fudge = 0.5;
	if(y < 0) fudge = -0.5;
	yp = (y-ymin)*lly/yrange + fudge;
	if(yp > ly) yp = ly;
	if(yp < 0) yp = 0;
	/* find associated x point */
	llx = lx;
	fudge = 0.0;
	if(x > 0) fudge = 0.5;
	if(x < 0) fudge = -0.5;
	xp = (x-xmin)*llx/xrange + fudge;
	
	if(xp > lx) xp = lx;
	if(xp < 0) xp = 0;
	/* place graph character in point x,y */
	*(ylp[yp] + xp) = gc;
	if(form & DB && xp < lx && xp > 0)	{
	/* draw line from point to x axis */
		yp -= 1;
		while(yp >= 1)	{
			*(ylp[yp] + xp) = fc;
			yp -= 1;
			}
	}
	return(ZERO);
}
gform(f)
int f;
{
	form = f;
	return (f);
}
sncopy(s,t,n)	/* copy t to s; terminate s */
char *s,*t;
int n;
{
	for( ; *t != ZERO && n > 0; n--)
		*s++ = *t++;
		*s = ZERO;
	return(n);
}
gprint(is,ofp)
char	*is;
FILE	*ofp;
{
	return(fputs(is,ofp));
}
