#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
#if	HUGE == 9999
#undef	HUGE
#define	HUGE 	(((unsigned) ~0) >> 1)
#endif
#ifndef		ZERO
#define		ZERO	0
#endif
/*
*/
#define         NDIVS   4               /* number of diversion files */
#define			DIVFILE					"/krXXXXXX.tmp"
/*EXTERN*/
/*STATIC*/
static	char	*tmpdir;
static  FILE    *dfp[NDIVS];            /* diversion file pointers */
static  char    *dfn[NDIVS];     		/* diversion file names */
static  char    *dbp[NDIVS];            /* buffers for diversions */
static  long    dad[NDIVS];             /* last read address */
static  int     dl[NDIVS];              /* number of lines */
/*
*/
int *
dl_adr(nv,is)			/* return address of d[0-3] counter */
char    *is;
{
	switch(kase(is))    {
	KASE('d','0'):  return(&dl[0]);
	KASE('d','1'):  return(&dl[1]);
	KASE('d','2'):  return(&dl[2]);
	KASE('d','3'):  return(&dl[3]);
	default:	return( (int *) ZERO);
	}
}
dl_add(nd,nl)   		/* add nl lines to dl[nd] */
{
	return(dl[nd] += nl);
}
dl_get(nd)				/* return dl[nd] */
{
	return(dl[nd]);
}
xdi(nv,is)      		/* divert output to file */
char    *is;
{
	auto    char    *xp[4];
	auto    int     nd;
	auto	int		ret;
/*
**	op	file	cnt
**	0	1		2
**	
**	c	close and unlink
**	a	add (open if necessary)
**	r	read
*/
	getqs(xp,4,is);
/**/
	nd = atoi(xp[1]);
/**/
	if(nd >= NDIVS) {
		errmsg("<bad diversion>\n");
		terror(FUBAR);
		}
/**/
	switch(*xp[0])  {
		case    'c':    ret = xdic(nv,nd);
						break;
		case    'w':    xdic(nv,nd);
		case    'a':    ret = xdio(nv,nd);
						break;
		case    'b':    ret = xdib(nv,nd,setvar(nv,xp[2],VERT,0,HUGE));
						break;
		case	'h':	ret = xdih(nv,is);
						break;
		case    'r':    ret = xdir(nv,nd,setvar(nv,xp[2],VERT,0,HUGE));
						break;
		default:        errmsg("<bad dv option> '%c'\n",*xp[0]);
						ret = xdih(nv,is);
	}
	return(ret);
}
xdih(nv,is)
char	*is;
{
	khint(kenv.pname,"DIVERSIONS");
	return(0);
}
xdiz()                  /* close and unlink all */
{
	auto    int     i;
	for(i = 0; i < NDIVS; i++)  xdic(0,i);
	return(0);
}
xdic(nv,nd)             /* close and unlink */
{
	if(dfp[nd]) {
		unlink(dfn[nd]);
		dfn[nd] = free_if(dfn[nd]);
		dbp[nd] = free_if(dbp[nd]);
		x[nv].ofp = dfp[nd] = xfclose(dfp[nd]);
		x[nv].ofp = x[0].ofp;
		dad[nd] = 0L;
		dl[nd] = x[nv].di = 0;
	}
	return(ZERO);
}
xdio(nv,nd)          /* open diversion */
int	nv;
int	nd;
{
	auto	char	ws[FNMSIZ];
	auto	char	*fn;
	auto	char	*mo = kenv.dosdos ? "r+b" : "r+";
	if(nv == 0) {
		errmsg("xdi: <diversion of home environment>\n");
		terror(FUBAR);
	}
/**/
/**/
	if(dfp[nd])	{
		fseek(dfp[nd],0L,2);
		x[nv].ofp = dfp[nd];
		x[nv].di = nd + 1;
		return(ZERO);
		}
/**/
	tmpdir = (tmpdir = kgetenv("TMPDIR")) ? tmpdir : "." ;
	strcpy(ws,tmpdir);
	strcat(ws,DIVFILE);
	fn = dfn[nd] = strsave(ws);
	maketemp(fn);
/**/
	if(filesize(fn) < 0)	{
		auto	FILE	*fp;
		fp = efopen(fn,"w");
		fp = xfclose(fp);
		}
	dfp[nd] = tefopen(fn,mo);
/**/
	dbp[nd] = emalloc(bufsiz(),"xdio");
	setbuf(dfp[nd],dbp[nd]);
/*
**  when diverting, x[nv].di = diversion number + 1
*/
	x[nv].di = nd + 1;
	x[nv].ofp = dfp[nd];
	return(ZERO);
}
xdib(nv,nd,nl)      	/* read nl blank lines of diversion */
{
#ifdef	USE_STACK
	auto	char	ls[BLKSIZ];
	auto	char	*lsu = ls + BLKSIZ - 1;
#else	USE_STACK
	auto	int		ll = bufsiz();
	auto	char	*ls = emalloc(ll,"xdib");
	auto	char	*lsu = ls + ll - 1;
#endif	USE_STACK
/**/
	if(!dfp[nd])	xerrmsg("xdib","read on closed diversion");
/**/
	if(fseek(dfp[nd],dad[nd],0) < 0)
					xerrmsg("xdib","bad seek");
/**/
	nl = nl >= 1 ? nl : HUGE;
/**/
	while(nl-- >= 1)	{
/**/
	if(!fgetlf(ls,lsu,dfp[nd]))	break;
/**/
	if(pws(ls) == 0)	{
		dl[nd] -= 1;
		dad[nd] = ftell(dfp[nd]);
		}
	else	break;
	}
/**/
	fseek(dfp[nd],0L,2);
/**/
#ifdef	USE_STACK
#else	USE_STACK
	ls = free_if(ls);
#endif	USE_STACK
	return(dad[nd]);
}
xerrmsg(os,is)
char	*os;
char	*is;
{
	errmsg("%s <%s>\n",os,is);
	terror(FUBAR);
}
xdir(nv,nd,nl)      	/* read nl lines of diversion */
{
/**/
	if(!dfp[nd])	xerrmsg("xdir","read on closed diversion");
/**/
	if(fseek(dfp[nd],dad[nd],0) < 0)
					xerrmsg("xdir","bad seek");
/**/
	nl = nl >= 1 ? nl : HUGE;
/**/
	dl[nd] -= rdfile(nv,dfp[nd],nl,0);
/**/
	dad[nd] = ftell(dfp[nd]);	/* save next read position */
/**/
	fseek(dfp[nd],0L,2);		/* position at end for next write */
/**/
	return(dad[nd]);
}
