#define	DEBUG
#undef	DEBUG
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
#ifdef	DEBUG
#define	MAXNUTS		16
static	int			nuts = 0;
#endif
/*EXTERNAL*/
#ifdef	USE_BS
extern	int	xbs();
#endif	USE_BS
setenv(nv)  /* SET ENVIRONMENT VARIABLES TO DEFAULTS */
int     nv;
{
	if(nv >= NENV)  {
		errmsg("setenv <bad ev number> '%d'\n",nv);
		filewalk();
	}
	x[nv].osx = x[nv].os;
	x[nv].osu = x[nv].os + BLKSIZ - 10;
	x[nv].ifp = stdin;
	x[nv].ofp = stdout;
/*START*/
	x[nv].ad = 1;
	x[nv].c2 = DC2;
	x[nv].cc = DCC;
	x[nv].ce = 0;
	x[nv].cf = FOR;
	x[nv].cp = 1;
	x[nv].fi = 1;
	x[nv].fn = 1;
	x[nv].hp = 0;
	x[nv].hs = DHS;
	x[nv].hy = DHY;
	x[nv].in = DIN;
	x[nv].lc = ' ';
	x[nv].li = 0;
	x[nv].ll = DLL;
	x[nv].ln = 0;
	x[nv].lo = 0;
	x[nv].ls = DLS;
	x[nv].lt = DLT;
	x[nv].nm = 0;
	x[nv].nn = 0;
	x[nv].no = DFN;
	x[nv].ns = 0;
	x[nv].pd = DPD;
	x[nv].pf = FOR;
	x[nv].pl = DPL;
	x[nv].pn = 2;
	x[nv].po = DPO;
	x[nv].px = DPI;
	x[nv].qc = DQC;
	x[nv].sv = 0;
	x[nv].ta = 0;
	x[nv].tc = '\t';
	x[nv].tf = 0;
	x[nv].ti = DTI;
	x[nv].tr = 0;
	x[nv].vp = 0;
	x[nv].vs = DVS;
/*STOP*/
	return(nv);
}
int *
varadr(nv,is)       /* find variable address */
char    *is;
{
	REG     struct  NUMREG  *nrx = (struct NUMREG *) NULL;
	REG     int     *ad = (int *) NULL;
/*
**	xcmd	pushes address	?xx
**	regfind	no push			xx
**	dl_adr	no push			xx
*/
	nrx = regfind(is+1);    /* named registers */
	if(nrx) return(ippush(&nrx->vlu));
/*
**  if no named register, then look for environment
**  variable
*/
	ad = xcmd(nv,is);       /* environment vars */
	if(ad)  return(ad);
	if(is[1] == 'd')	{
		/* diversion lines */
		if(ad = dl_adr(nv,is+1)) return(ippush(ad));
		}
	errmsg("<unknown variable> '%3.3s'\n",is);
	terror(FUBAR);
	return( (int *) NULL );
}
xha(nv,is)
char    *is;
{
	if(!isnull(is)) {
	fputs(is,stderr);
	putc('\n',stderr);
	}
	sleep(5);
	return(ZERO);
}
int	*
xcmd(nv,is)         /* EXECUTE COMMANDS || GET VARIABLE */
char    *is;
{
	extern	char	*filepush();
	extern	char	*filepop();
	auto	char    *x1 = NULL;
	auto	char    *x3 = NULL;
	auto	int     vr = 0;
	auto	FUNCP	fadr = (FUNCP) NULL;
	auto	int     *vadr = (int *) NULL;
#ifdef	DEBUG
	if(kenv.diagno & DB)	{
	fprintf(stderr,"xcmd(%u,%u) ",nv,is);
	funxesc(is,stderr);
	}
#endif	DEBUG
	savecmd(is);
/*
**  BREAKING OR NON-BREAKING?
**
**  take care not to screw up breaks when this is called
**  to return an address, not to execute a command
*/
/**/
	if(is[0] == x[nv].cc)   x[nv].br = 1;
	else
	if(is[0] == x[nv].c2)   x[nv].br = 0;
/**/
/*  CALL FUNCTION OR GET VARIABLE ? */
/**/
	if(is[0] == x[nv].qc)   vr = 1;
	else                    vr = 0;
	x1 = is + 1;
	x3 = is + 3;
	while(isspace(*x3)) ++x3;
	switch(kase(x1))    {
/*  non environment items */
	KASE('d','b'):      fadr = xdb;  vadr = &db; break;
	KASE('e','v'):
	KASE('n','v'):      fadr = xnv;  vadr = &nv; break;
/*  nroff kludges */
	KASE('n','h'):      fadr = xhy; vadr = &x[nv].hy;
					x3 = "0";
					break;
	KASE('n','a'):      fadr = xad; vadr = &x[nv].ad;
					x3 = "0";
					break;
	KASE('n','f'):      fadr = xfi; vadr = &x[nv].fi;
					x3 = "0";
					break;
/*  environment variables and functions */
	KASE('a','b'):      fadr = xab; vadr = NULL; break;
	KASE('a','d'):      fadr = xad; vadr = &x[nv].ad; break;
	KASE('a','m'):      fadr = xam; vadr = NULL; break;
	KASE('a','s'):      fadr = xas; vadr = NULL; break;
	KASE('b','p'):      fadr = xbp; vadr = NULL; break;
	KASE('b','r'):      fadr = xbr; vadr = &x[nv].br; break;
#ifdef	USE_BS
	KASE('b','s'):      fadr = xbs; vadr = NULL; break;
#endif	USE_BS
	KASE('c','2'):      fadr = xc2; vadr = &x[nv].c2; break;
	KASE('c','c'):      fadr = xcc; vadr = &x[nv].cc; break;
	KASE('c','d'):      fadr = xcd; vadr = NULL; break;
	KASE('c','e'):      fadr = xce; vadr = &x[nv].ce; break;
	KASE('c','f'):      fadr = NULL; vadr = &x[nv].cf; break;
	KASE('c','h'):      fadr = xch; vadr = NULL; break;
	KASE('c','p'):      fadr = xpn; vadr = &x[nv].cp; break;
	KASE('d','a'):
	KASE('d','e'):      fadr = xde; vadr = NULL; break;
	KASE('d','i'):      fadr = xdi; vadr = &x[nv].di; break;
	KASE('d','s'):      fadr = xds; vadr = NULL; break;
	KASE('d','t'):      fadr = xdt; vadr = NULL; break;
	KASE('d','v'):
	KASE('e','d'):      fadr = xed; vadr = NULL; break;
	KASE('e','e'):      fadr = xee; vadr = NULL; break;
	KASE('e','l'):      fadr = xel; vadr = NULL; break;
	KASE('e','m'):      fadr = xem; vadr = NULL; break;
	KASE('e','x'):      fadr = xex; vadr = NULL; break;
	KASE('f','i'):      fadr = xfi; vadr = &x[nv].fi; break;
	KASE('f','l'):      fadr = xfl; vadr = NULL; break;
	KASE('f','n'):      fadr = xfn; vadr = &x[nv].fn; break;
	KASE('f','s'):      fadr = xfs; vadr = NULL; break;
	KASE('f','t'):      fadr = xft; vadr = &x[nv].cf; break;
	KASE('f','v'):      fadr = xfv; vadr = NULL; break;
	KASE('g','e'):      fadr = xge; vadr = NULL; break;
	KASE('h','a'):      fadr = xha; vadr = NULL; break;
	KASE('h','p'):      fadr = xhp; vadr = &x[nv].hp; break;
	KASE('h','s'):      fadr = xhs; vadr = &x[nv].hs; break;
	KASE('h','y'):      fadr = xhy; vadr = &x[nv].hy; break;
	KASE('i','e'):      fadr = xie; vadr = &x[nv].ie; break;
	KASE('i','f'):      fadr = xif; vadr = NULL; break;
	KASE('i','g'):      fadr = xig; vadr = &x[nv].ig; break;
	KASE('i','n'):      fadr = xin; vadr = &x[nv].in; break;
	KASE('i','p'):      fadr = xip; vadr = &x[nv].ip; break;
	KASE('i','x'):      fadr = xix; vadr = &ix; break;
	KASE('l','c'):      fadr = xlc; vadr = &x[nv].li; break;
	KASE('l','i'):      fadr = xli; vadr = &x[nv].li; break;
	KASE('l','j'):      fadr = xlj; vadr = NULL; break;
	KASE('l','l'):      fadr = xll; vadr = &x[nv].ll; break;
	KASE('l','n'):      fadr = xpn; vadr = &x[nv].pn; break;
	KASE('l','o'):      fadr = xlo; vadr = &x[nv].lo; break;
	KASE('l','s'):      fadr = xls; vadr = &x[nv].ls; break;
	KASE('l','t'):      fadr = xlt; vadr = &x[nv].lt; break;
	KASE('m','o'):      return(0);
	KASE('n','e'):      fadr = xne; vadr = NULL; break;
	KASE('n','m'):      fadr = xnm; vadr = &x[nv].nm; break;
	KASE('n','n'):      fadr = xnn; vadr = &x[nv].nn; break;
	KASE('n','o'):      fadr = xno; vadr = &x[nv].no; break;
	KASE('n','r'):      fadr = xnr; vadr = NULL; break;
	KASE('n','s'):      fadr = xns; vadr = &x[nv].ns; break;
	KASE('n','t'):      fadr = xnt; vadr = &nt; break;
	KASE('n','x'):      fadr = xnx; vadr = NULL; break;
	KASE('p','d'):      fadr = xpd; vadr = &x[nv].pd; break;
	KASE('p','f'):      fadr = NULL; vadr = &x[nv].pf; break;
	KASE('p','i'):      fadr = xpi; vadr = &x[nv].pi; break;
	KASE('p','l'):      fadr = xpl; vadr = &x[nv].pl; break;
	KASE('p','m'):      fadr = xpm; vadr = NULL; break;
	KASE('p','n'):      fadr = xpn; vadr = &x[nv].pn; break;
	KASE('p','o'):      fadr = xpo; vadr = &x[nv].po; break;
	KASE('p','t'):      fadr = xpt; vadr = NULL; break;
	KASE('p','v'):      fadr = xpv; vadr = NULL; break;
	KASE('p','x'):      fadr = xpx; vadr = &x[nv].px; break;
	KASE('r','d'):      fadr = xrd; vadr = &x[nv].rd; break;
	KASE('r','j'):      fadr = xrj; vadr = NULL; break;
	KASE('r','m'):      fadr = xrm; vadr = NULL; break;
	KASE('r','n'):      fadr = xrn; vadr = NULL; break;
	KASE('r','r'):      fadr = xrr; vadr = NULL; break;
	KASE('r','w'):      fadr = xrw; vadr = NULL; break;
	KASE('s','h'):      fadr = xsh; vadr = NULL; break;
	KASE('s','l'):      fadr = xsl; vadr = &sl; break;
	KASE('s','o'):      fadr = xso; vadr = &x[nv].so; break;
	KASE('s','p'):      fadr = xsp; vadr = NULL; break;
	KASE('s','v'):      fadr = xsv; vadr = &x[nv].sv; break;
	KASE('t','a'):      fadr = xta; vadr = &x[nv].tc; break;
	KASE('t','c'):      fadr = xtc; vadr = &x[nv].tc; break;
	KASE('t','d'):      fadr = xtd; vadr = NULL; break;
	KASE('t','e'):      fadr = xte; vadr = &x[nv].tf; break;
	KASE('t','f'):      fadr = xtf; vadr = &x[nv].tf; break;
	KASE('t','h'):      fadr = xth; vadr = &x[nv].tf; break;
	KASE('t','i'):      fadr = xti; vadr = &x[nv].ti; break;
	KASE('t','l'):      fadr = xtl; vadr = NULL; break;
	KASE('t','m'):      fadr = xtm; vadr = NULL; break;
	KASE('t','r'):      fadr = xtr; vadr = &x[nv].tr; break;
	KASE('t','s'):      fadr = xts; vadr = &x[nv].tf; break;
	KASE('v','p'):      fadr = xvp; vadr = &x[nv].vp; break;
	KASE('v','s'):      fadr = xvs; vadr = &x[nv].vs; break;
	KASE('w','h'):      fadr = xwh; vadr = NULL; break;
	KASE('z','s'):      fadr = xzs; vadr = NULL; break;
	KASE('z','t'):      fadr = xzt; vadr = NULL; break;
	KASE('B',0): 		x3 = is+1; fadr = zft; vadr = NULL; break;
	KASE('B','F'): 		x3 = is+1; fadr = zft; vadr = NULL; break;
	KASE('I',0): 		x3 = is+1; fadr = zft; vadr = NULL; break;
	KASE('I','F'): 		x3 = is+1; fadr = zft; vadr = NULL; break;
	KASE('U','F'): 		x3 = is+1; fadr = zft; vadr = NULL; break;
	KASE('R','F'): 		x3 = is+1; fadr = zft; vadr = NULL; break;
	KASE('R',0): 		x3 = is+1; fadr = zft; vadr = NULL; break;
	KASE('P','F'): 		x3 = is+1; fadr = zft; vadr = NULL; break;
	default:        	break;
	}
	if(vr)  {
/*  
**  all variables are treated as writable
**  This might be changed; type is implicit in
**  ippush but not used except by assignment
**  function
*/
		if(vadr)	return(ippush(vadr));
		else    	return(NULL);
		}
	else
	if(fadr) {
		(*fadr)(nv,x3);
		return(NULL);
		}
	else
	if(isatty(fileno(x[nv].ofp)))    {
		kenv.diagno = DA | DB | DC;
#ifdef	DEBUG
		if(kenv.diagno & DB)	shit(is);
#endif
		errmsg("xcmd: <unknown command> %s '%s'\n",
			filepush(filepop()),is);
#ifdef	DEBUG
		if(nuts++ >= MAXNUTS)	dump("shit!!!!");
#endif
	}
	return(NULL);
}
#ifdef	DEBUG
shit(is)
char	*is;
{
	fprintf(stderr,"shit!!!! ");
	funxesc(is,stderr);
	query(stderr);
}
#endif
#ifdef	USE_BS
xbs(nv,is)
char	*is;
{
	return(xtxt(nv,is));
}
#endif	USE_BS
xhs(nv,is)      /* set horizontal spacing */
char    *is;
{
	return(x[nv].hs = setvar(nv,is,ABSO,x[nv].hs,DHS));
}
xvs(nv,is)      /* set vertical spacing */
char    *is;
{
	return(x[nv].vs = setvar(nv,is,ABSO,x[nv].vs,DVS));
}
xed(nv,is)      /* environment duplicator */
char    *is;
{
	auto    int     tv = atoi(is);
	if(tv == nv || tv >= NENV)  {
		errmsg("xed: <bad environment> '%d'\n",tv);
		terror(FUBAR);
		}
/*
**  make the specified environment look like the current
**  environment
*/
	cpbyte((char*) &x[tv].aa,
		(char *) &x[nv].aa,
			(char *) &x[nv].wc);
	return(ZERO);
}
char	*
cpbyte(os,is,us)
char    *os, *is, *us;
{
	REG     char    *osx = os;
	REG     char    *isx = is;
	REG     char    *usx = us;
	while(isx <= usx)   *osx++ = *isx++;
	return(os);
}
#ifdef  kr_setenv_x
terror(){}
filewalk(){}
main()
{
	auto    char    ls[BLKSIZ];
	auto    char    *lsx = ls + 1;
	auto    int     *ty,    *ad;
	setenv(0);
	setenv(1);
	setenv(2);
	while(putchar('?'),fflush(stdout),gets(ls)) 
	if(ls[0] == '.')    switch(kase(lsx))   {
	KASE('!','!'):          system(ls+3);break;
	KASE('v','a'):          varadr(0,ls+3);
						ty = ippop();
						ad = ippop();
						printf("ty = '%c' ad = %d *ad = %d\n",
							*ty, ad, *ad);
	default:            break;
	}
	else    ;
}
#endif
