/*
systems without vsprintf require the KLUDGE version below.  this
is highly system dependent code.  unfortunately 42 does not have
vsprintf.  rather than use a scratch file and write to it with
vprintf (which is in 42), a copy of vsprintf from 43 was swiped
and added to unxlib for 42.
*/
/*UNXLIB*/
/*DOSLIB*/
#ifdef  V29
#define	KLUDGE
#define MONITOR
#endif
#ifdef  V42
#define MONITOR
#endif
/**/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#ifndef     xa_dcl
#include    "ksysvarg.h"
#endif
/**/
#include	"ksysprot.h"
/**/
#define		USAGE	"%s/USAGE/%s.err"
#define		V_ERRMSG	1
#define		V_PRINTE	2
#define		V_PRINTF	4
#define		V_PRTERR	8
#define		V_PRTWHO	16
/**/
/*EXTERN*/
extern	char	*fputout();
extern	void	kmessg();
extern  int     errno;
extern  int     sys_nerr;
extern  char    *sys_errlist[];
extern	KENV	kenv;
extern	char	*cltt;
extern	char	*clce;
extern	char	*clcl;
extern	char	*clso;
extern	char	*clse;
extern	char	*clbs;
extern	char	*clho;
/*STATIC*/
static		char		kbuf[BUFSIZ];
static		char		lerr[FNMSIZ];	/* last error message */
static      xa_list     ap;         /* global arg pointer */
static      char        *fm;        /* global format pointer */
static      int         tt_set;
static      FILE    	*stdmsg   =   stderr;
static      char    	*prg    =   "-----";
static		int			beep	=	'\007';
/**/
#ifdef  MONITOR
/*
**  diserr and disrec provide for sending copies of error
**  message to a monitor file.  this may be used to determine
**  which functions are causing users particular problems
*/
static      int     drec    =   0;              /* record ? */
static      FILE    *derr   =   (FILE*) NULL;   /* recording file */
FILE    *
diserr()
{
	if(drec && derr)    return(derr);
	else                return((FILE*)NULL);
}
disrec(ty)              /* diagnostic recording ? */
{
	static  char    *db = NULL;
	auto    char    ws[FNMSIZ];
	auto	char	*user;
	auto	char	*pubkin;
/**/
	drec = 0;
/**/
	if(ty == 0) {
		if(derr)    {
			fclose(derr);
			derr = (FILE*) NULL;
			db = free_if(db);
			}
		return(drec = 0);
		}
/**/
	derr = (FILE *) NULL;
/**/
	pubkin = kgetenv("PUBKIN");
	if(!pubkin)	return(-1);
/**/
	user = (user = kgetenv("USER")) ? user : NULL;
	if(!user)
		user = (user = getlogin()) ? user : NULL;
	if(!user)	user = "fubar";
/**/
	sprintf(ws,USAGE,pubkin,user);
	derr = fopen(ws,"a");
	if(!derr)	return(-2);
/**/
	if(!(db = emalloc(bufsiz(),"disrec")))
				return(-3);
/**/
	setbuf(derr,db);
/**/
	chmod(ws,0777);
/**/
	return(drec = 1);
}
#else
FILE    *
diserr()
{
	return((FILE*)NULL);
}
disrec()
{
	return(ZERO);
}
#endif
/*
*/
FILE    *
disout(dfp)             /* set default error msg file */
FILE *dfp;
{
	if(dfp == NULL)	return(stdmsg = stderr);
	else			return(stdmsg = dfp);
}
char    *
disnme(is)              /* set program name for error msg */
char    *is;
{
/*
	the name passed to this must be a permanent string
*/
	if(!tt_set) termcap();
	return(prg = is == NULL ? "-----" : is);
}
void
printff(xa_alist)       /* print to stdout with flush */
xa_dcl
{
	xa_start(ap);
	fm = xa_arg(ap,char *);
	vsprintf(kbuf,fm,ap);
	kmessg(V_PRINTF,kbuf);
	return;
}
void
prwho(xa_alist)			/* print to stderr with prog name */
xa_dcl
{
	xa_start(ap);
	fm = xa_arg(ap,char *);
	vsprintf(kbuf,fm,ap);
	kmessg(V_PRTWHO,kbuf);
	return;
}
void
prterr(xa_alist)				/* sys err msg with memo and id */
xa_dcl
{
	xa_start(ap);
	fm = xa_arg(ap,char *);
	vsprintf(kbuf,fm,ap);
	kmessg(V_PRTERR,kbuf);
	return;
}
void
print(xa_alist)         /* a printf to stderr */
xa_dcl
{
	xa_start(ap);
	fm = xa_arg(ap,char *);
	vsprintf(kbuf,fm,ap);
	kmessg(V_PRINTE,kbuf);
	return;
}
void
errmsg(xa_alist)		/* bells and whistles error message */
xa_dcl
{
	xa_start(ap);
	fm = xa_arg(ap,char *);
	vsprintf(kbuf,fm,ap);
	kmessg(V_ERRMSG,kbuf);
	return;
}
void
kmessg(ty,os)		/* general print function */
char	*os;
{
	auto	int		save = 0;
	fflush(stdout);
	switch(ty)	{
		case	V_PRTWHO:
			fputout(prg,stdmsg);
			fputs(" ",stdmsg);
			/* deliberate drop through */
		case	V_PRINTE:
			fputs(os,stdmsg);
			break;
		case	V_PRINTF:
			fputs(os,stdout);
			break;
		case	V_ERRMSG:
			fputs(prg,stdmsg);
			fputout(" ERROR ",stdmsg);
			fputs(os,stdmsg);
			save = 1;
			break;
		case	V_PRTERR:
			if(errno >= sys_nerr)	{
				errmsg("prterr <errno out of range> %d >= %d\n",
					errno,sys_nerr);
					return;
				}
			fputs(prg,stdmsg);
			fputs(" ",stdmsg);
			fputout(sys_errlist[errno],stdmsg);
			fputs(" ",stdmsg);
			fputs(os,stdmsg);
			fputs("\n",stdmsg);
			{
			auto	char	*osx;
			strrev(os);
			osx = os + strlen(os);
			strcpy(osx,sys_errlist[errno]);
			strcat(osx," ");
			strrev(osx);
			strrev(os);
			strcat(os,"\n");
			}
			save = 1;
			break;
		default:
			dump("kmessg: bad type");
			break;
		}
	fflush(stdout);
	if(save)	{
		strkat(lerr,lerr+FNMSIZ-1,os);
#ifdef	MONITOR
		if(derr)	{
			fprintf(derr,"%s %s\n",prg,lerr);
			fflush(derr);
			}
#endif
		}
	return;
}
char	*
fputout(os,fp)
FILE	*fp;
char	*os;
{
	fprintf(stdmsg,"%c%s%s%s",beep,clso,os,clse);
	return(os);
}
char	*
getlerr(fp) 			/* return last recorded error */
FILE	*fp;
{
/*
	print if FILE pointer given, otherwise return string
*/
	if(fp)	{
		fputs(kenv.pname,fp);
		fputs(" ERROR ",fp);
		fputs(lerr,fp);
	}
	return(lerr);
}
#ifdef      TEST
KENV        kenv;
void
terror(ty)
int		ty;
{
	exit(ty);
	return;
}
fubar(ty)
int		ty;
{
	terror(ty);
	return;
}
char    *
main()
{
	auto	char	ls[BUFSIZ];
	auto	int		pc = '?';
	auto	FILE	*fp;
	auto	double	value;
	extern	double	atof();
	while(putchar(pc), fflush(stdout), gets(ls))	{
	switch(ls[0])	{
		case	'q':	fclose(stdin);
						break;
		case	'!':	system(ls+1);
						break;
		case	'D':	
/*
	x != x does not work as imagined
*/
						kenv.dosdos = !kenv.dosdos;
						pc = kenv.dosdos ? '#' : '?';
						break;
		case	'P':	value = atof(ls+1);
						print("%g %10.5f\n",value,value);
						break;
		case	'G':	getlerr(stdout);
						break;
		case	'N':	disnme(strsave(strcnd(ls+1)));
						break;
		case	'O':	fp = efopen(strcnd(ls+1),"r");
						xfclose(fp);
						break;
		case	'W':	prwho("[%s]\n",strcnd(ls+1));
						break;
		case	'X':	errmsg("%s\n",strcnd(ls+1));
						break;
		case	'E':	print("<%s>\n",strcnd(ls+1));
						break;
		default:
		case	'?':	puts("!cmd");
						puts("q quit");
						puts("? hint");
						puts("P value [floating test]");
						puts("D dostoggle");
						puts("E string [print]");
						puts("G getlerr");
						puts("N disnme");
						puts("O file_name [open/close]");
						puts("W string [prwho]");
						puts("X string [errmsg]");
		}
	}
	exit(0);
}
#endif
#ifdef	KLUDGE
vsprintf(buf,fmt,arg)
char	*buf;
char	*fmt;
int		*arg;
{
	auto	int		argp[8];
	auto	int		ret;
	memcpy( (char *) argp, (char *) arg, sizeof(argp) );
	ret = sprintf(buf,fmt,argp[0],argp[1],argp[2],argp[3],
		argp[4],argp[5],argp[6],argp[7]);
	return( ret );
}
#endif	/*KLUDGE*/
