/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/*EXTERN*/
extern		KENV	kenv;
/**/
#define		CCEX	1		/* C language escapes */
#define		OCEX	2		/* C octal constants */
#define		CNEX	4		/* ^X control codes */
#define		PREX	8
/*EXTERN*/
#ifdef	CAN_PROTO
extern int cnxesc(int);
extern int ocxesc(char *);
extern int ccxesc(int);
extern int xescxc(int);
extern int xescmo(int);
#else
extern int cnxesc();
extern int ocxesc();
extern int ccxesc();
extern int xescxc();
extern int xescmo();
#endif
/*STATIC*/
static	char	*xhint();
static	int		ox = CCEX|OCEX;
static	int		xc = ESC;
/**/
xescxc(ty)		/* set the escape character */
int		ty;
{
	auto	int	cxc = xc;
	xc = ty;
	return(cxc);
}
/**/
xescmo(ty)		/* change the escape mode */
int		ty;
{
	auto	int	cox = ox;
	ox = ty;
	return(cox);
}
static	char	*
xhint(is)
char	*is;
{
	static	char	*hx[] = {
	"=xesc(string)",
	"\\=?     hint",
	"\\=0     no escapes",
	"\\=1     C escapes (bfnrtv)",
	"\\=2     octal escapes (\000)",
	"\\=4     control escapes (\@, \A, ..., \_)",
	"\\=c     escape character becomes c [default \\]",
	"=",
	}	;
	if(*is == '?')	{
		prhint(hx,sizeof(hx)/sizeof(char**),ZERO,ZERO);
		}
	else
	if(isdigit(*is))	{
		xescmo(atoi(is));
		}
	else	{
		xescxc(*is);
		}
	if(is[1] != ZERO)	return(xesc(is+1));
	else				return(NULL);
}
char	*
xesc(is)	/* expand ^X \c and \000 escapes */
char	*is;
{
	REG		char	*isx = is;
	REG		char	*osx = is;
	REG		int		cx = ZERO;
/**/
	if(*isx == xc && isx[1] == '=')	return(xhint(isx+2));
/**/
	while(*isx != ZERO)		{
	if(*isx == xc)	{
		if(isx[1] == xc)	{
			*osx++ = isx[1];
			isx += 2;
			continue;
			}
		else
		if((int) (ox & CCEX) && islower(isx[1]) && (cx = ccxesc(isx[1])))	{
			*osx++ = cx;
			isx += 2;
			continue;
			}
		else
		if((ox & CNEX) && (isx[1] >= '@' && isx[1] <= '_'))	{
			*osx++ = cx = (isx[1] - '@');
			isx += 2;
			}
		else
		if((ox & OCEX) && isdigit(isx[1]) &&
			isdigit(isx[2]) && isdigit(isx[3]))	{
			*osx++ = cx = ocxesc(isx+1);
			isx += 4;
			continue;
			}
		}
	*osx++ = *isx++;
	}
	*osx = ZERO;
	return(is);
}
ccxesc(cx)		/* expand the "C" escapes */
int		cx;
{
	auto	int		i;
	static	struct	CESCAPE	{
		char	cx;		/* raw value */
		char	xc;		/* converted value */
		}	ces[] = {
			'b',	'\b',
			'f',	'\f',
			'n',	'\n',
			'r',	'\r',
			't',	'\t',
			'v',	'\v',
			'\\',	'\\',
		}	;
/**/
	for(i = 0; i < sizeof(ces)/sizeof(struct CESCAPE) ; i++)	{
	if(cx == ces[i].cx)	return(ces[i].xc);
	}
/**/
	return(ZERO);
}
ocxesc(is)		/* octal constants as in \001 */
char	*is;
{
	auto	int		ro;
	sscanf(is,"%o",&ro);
	return(ro);
}
cnxesc(cx)		/* control codes as in ^G, ^F */
int		cx;
{
	if(cx >= '\100' && cx <= '_')	cx -= '\100';
	else							cx = 0;
	return(cx);
}
#ifdef	TEST
KENV	kenv;
void
terror(ty)
{
	exit(ty);
}
main()
{
	auto	char	ls[FNMSIZ];
	auto	char	*lx;
	disnme(kenv.pname = "xesc");
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
	case	'?':	xesc("\\=?");break;
	case	'q':	fclose(stdin);
					break;
	case	'@':	xescxc(ls[1]);
					break;
	case	'#':	ox = atoi(ls+1);
					break;
	case	'!':	system(ls+1);
					break;
	default:		lx = xesc(ls);
					if(lx)	funxesc(lx,stdout);
					break;
	}
}
#endif
