/*
|	the routines here are designed to emulate fixed size output devices.
|	by pretending to write to such a device, we determine the number of
|	segments needed for large files.  during this process linked files are
|	also checked.
*/
#include	"pdtar.h"
#include	"pdproto.h"
/**/
/*LOCAL*/
/*GLOBAL*/
#define		NEXT	128
struct	EXTENT	{
	int		disk;
	FSIZE	begin;
	FSIZE	wsize;
	}	extent[NEXT];
/*EXTERN*/
char	*
samefile(inode,name)	/* is current item a link to an earlier file? */
ino_t	inode;
char	*name;
{
	static	char	*here = "samefile";
	static	char	ls[NAMSIZ];
	auto	ino_t	xnode;
/**/
	nullassign(name,here);
/**/
	rewind(lfp);
/**/
	while(fscanf(lfp,"%u %s",&xnode,ls) != EOF)	{
#ifdef	DEBUG
		fprintf(stderr,"%u %s\n",xnode,ls);
#endif
		if(xnode == inode)	return(ls);
		}
/**/
	fprintf(lfp,"%u %s\n",inode,name);
/**/
	return(NULL);
}
doindex(f_name,phstat)	/* index files */
char	*f_name;
STAT	*phstat;
{
	static	char	*here = "doindex";
	auto	FSIZE	osize = 0L;
	auto	FSIZE	begin = 0L;
	auto	FSIZE	wsize = 0L;
/**/
	nullassign(f_name,here);
/**/
	osize = phstat->st_size;
/**/
	device.extno = device.extotal = 0;
	device.efsize = osize;
/**/
#ifdef	MSDOS
#else
	if(phstat->st_nlink >= 2)	{
		auto	char	*f_link;
		f_link = samefile(phstat->st_ino,f_name);
		if(f_link)	{
			nlinks += 1;
			zwrfile((long) BLKSIZ);
			fprintf(xfp,"L %u %s %s\n",phstat->st_ino,f_name,f_link);
			return(0);
			}
		}
#endif
/**/
	fprintf(xfp,"F %u %s %ld ",phstat->st_ino,f_name,device.efsize);
/**/
	while(device.bpf && device.extno < NEXT && osize >= 1L)	{
		zwrfile((long) BLKSIZ);		/* header */
		osize -= (wsize = zwrfile(osize));
		device.extno = setextent(ndisk,begin,wsize);
		begin += wsize;
		}
/**/
	if(device.extno >= NEXT)	{
		where(here);
		fprintf(stderr,"<too many segments>\n");
		terror(FUBAR);
		}
/**/
	if(device.bpf == 0)	{
		device.extno = setextent(ndisk,begin,osize);
		}
/**/
	fprintf(xfp,"%d !",device.extotal = device.extno);
/**/
	for(device.extno = 0; device.extno < device.extotal; device.extno++)	{
		fprintf(xfp,"E %d %d %ld %ld ",device.extno,
			extent[device.extno].disk,
			extent[device.extno].begin,
			extent[device.extno].wsize);
		}
/**/
	fprintf(xfp,"\n");
/**/
	nfiles += 1;
/**/
	nsplit = (device.extotal >= 2) ? (nsplit + 1) : nsplit;
/**/
	return(0);
}
setextent(ndisk,begin,wsize)		/* just to reduce clutter */
int		ndisk;
long	begin;
long	wsize;
{
	extent[device.extno].disk = ndisk;
	extent[device.extno].begin = begin;
	extent[device.extno].wsize = wsize;
	return(device.extno += 1);
}
FSIZE
zwrfile(osize)		/* code should parallel wrfile */
FSIZE	osize;
{
	auto	FSIZE	wsize = 0L;
	if(device.wbc && (device.bpf - device.wbc) <= SLOP)	{
		device.wbc = 0;
		ndisk += 1;
		}
	while(osize >= 1 && (device.bpf - device.wbc) > SLOP)	{
		if(osize >= BLKSIZ)	{
			wsize += BLKSIZ;
			osize -= BLKSIZ;
			}
		else	{
			wsize += osize;
			osize -= osize;
			}
		device.wbc += 1;
		}
	return(wsize);
}
